import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintStream;
import java.io.Reader;
import java.io.Writer;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Set;
import javax.imageio.ImageIO;

/**
 *
 */
public class makeit {

    static Hashtable<String, String> AJS_SIZE;
    static Hashtable<String, String> AJS_SIZE2;

    /**
     *
     */
    public static void main(String[] args) {
        AJS_SIZE = new Hashtable<String, String>();

        AJS_SIZE.put("arquimedes_be",                  "width=\"1112\" height=\"814\"");
        AJS_SIZE.put("arquimedes_bv",                  "width=\"1112\" height=\"814\"");
        AJS_SIZE.put("arquimedes_bv_mobile",      "width=\"540\" height=\"960\"");
        AJS_SIZE.put("geometria_se",                  "width=\"1112\" height=\"814\"");
        AJS_SIZE.put("geometria_sv",                  "width=\"800\" height=\"456\"");

        AJS_SIZE2 = new Hashtable<String, String>();

        AJS_SIZE2.put("arquimedes_be",                    "value=\"1112x814\"");
        AJS_SIZE2.put("arquimedes_bv",                    "value=\"1112x814\"");
        AJS_SIZE2.put("arquimedes_bv_mobile",       "value=\"540x960\"");
        AJS_SIZE2.put("geometria_se",                   "value=\"1112x814\"");
        AJS_SIZE2.put("geometria_sv",                   "value=\"800x456\"");
        Set<String> sizes = AJS_SIZE.keySet();

        for (String size:sizes) {
            makeit.processFile(new File("index.html"), size);
        }
    }

    /**
     *
     */
    static void processFile(File file, String sceneSize) {
        Vector<String> content = makeit.read(file);
        String str;
        for (int i = 0; i < content.size(); i++) {
            str = content.get(i);
            if ( str.indexOf("width=\"1112\" height=\"814\"") > -1 ) {
                content.set(i, "    <ajs name=\"Descartes\" code=\"Descartes\" " + AJS_SIZE.get(sceneSize) +">");
            } else if ( str.indexOf("value=\"1112x814\"") > -1 ) {
                content.set(i, "      <param name=\"tamaño\" "+ AJS_SIZE2.get(sceneSize) +">");
                break;
            } 
        }
        String strContent = "";
        String writePath = file.getAbsoluteFile().getParentFile().getAbsolutePath() + File.separator + sceneSize + ".html";
        for (int i = 0; i < content.size(); i++) {
            strContent += (String)content.get(i);

            if (i < content.size()-1) {
                strContent += "\r\n";
            }
        }

        System.out.println(writePath);
        /*
	if (writePath.indexOf("geometria")>-1) { 
	    strContent=strContent.replace("book_n=_DEMO_","book_n=_GEOMETRIA_VISUAL_");
	}
	if (writePath.indexOf("euclidiana")>-1) { 
	    strContent=strContent.replace("book_n=_DEMO_","book_n=_GEOMETRIA_CLASICA_");
	}
	if (writePath.indexOf("calculo")>-1) { 
	    strContent=strContent.replace("book_n=_DEMO_","book_n=_CALCULO_");
	}
	*/
	if (writePath.indexOf("_bv")>-1) { 
	    strContent=strContent.replace("onlyPG3=0;onlyViewer=0","onlyPG3=0;onlyViewer=1");
	}
	if (writePath.indexOf("_se")>-1) {
	    strContent=strContent.replace("onlyPG3=0;onlyViewer=0","onlyPG3=1;onlyViewer=0");
	}
	if (writePath.indexOf("_sv")>-1) {
	    strContent=strContent.replace("onlyPG3=0;onlyViewer=0","onlyPG3=1;onlyViewer=1");
	 }
        makeit.write(strContent, writePath);
    }

    /**
     *
     */
    static Vector<String> read(File file) {
        try {
            FileInputStream FIS = new FileInputStream(file);
            InputStreamReader ISR = new InputStreamReader((InputStream)FIS, "UTF-8");
            BufferedReader BR = new BufferedReader(ISR);

            String str;
            Vector<String> vector = new Vector<String>();

            while ((str = BR.readLine()) != null) {
                vector.addElement(str);
            }
            BR.close();

            return vector;
        }
        catch (Exception err) {
            err.printStackTrace();
            return null;
        }
    }

    /**
     *
     */
    static void write(String filename, String content) {
        try {
            content = content.replace("/", File.separator);
            content = content.replace("\\", File.separator);
            File file = new File(content);
            file.mkdirs();
            if (file.exists()) {
                file.delete();
            }
            FileOutputStream FOS = new FileOutputStream(content);
            OutputStreamWriter OSW = new OutputStreamWriter((OutputStream)FOS, "UTF-8");
            BufferedWriter BW = new BufferedWriter(OSW);
            BW.write(filename);
            BW.flush();
            BW.close();
        }
        catch (Exception err) {
            err.printStackTrace();
        }
    }
}